package com.javacodegeeks.http.client

import java.util.UUID
import akka.stream.ActorMaterializer
import akka.actor.ActorSystem
import akka.http.scaladsl.Http
import akka.http.scaladsl.model.HttpRequest
import akka.stream.scaladsl.Sink
import akka.stream.scaladsl.Source
import akka.http.scaladsl.unmarshalling.Unmarshal
import scala.util.Success
import scala.concurrent.Future

object SimpleClient extends App {
  import akka.http.scaladsl.marshallers.sprayjson.SprayJsonSupport._
  import spray.json.DefaultJsonProtocol._

  implicit val system = ActorSystem()
  implicit val dispatcher = system.dispatcher
  implicit val materializer = ActorMaterializer()
  implicit val userFormat = jsonFormat4(User)

  val response: Future[Seq[User]] =
    Http()
      .singleRequest(HttpRequest(uri = "http://localhost:58080/users"))
      .flatMap { response => Unmarshal(response).to[Seq[User]] }
  
   response
     .map(println(_))
     .andThen { case _ => system.terminate() }
}