package com.javacodegeeks.http.client

import akka.actor.ActorSystem
import akka.stream.ActorMaterializer
import akka.http.scaladsl.model.HttpResponse
import akka.http.scaladsl.Http
import scala.concurrent.Future
import akka.stream.scaladsl.Source
import scala.util.Try
import akka.stream.scaladsl.Sink
import akka.http.scaladsl.model.HttpRequest
import scala.util.Success
import java.util.UUID
import akka.http.scaladsl.unmarshalling.Unmarshal

object StreamingClient extends App {
  import akka.http.scaladsl.marshallers.sprayjson.SprayJsonSupport._
  import spray.json.DefaultJsonProtocol._

  implicit val system = ActorSystem()
  implicit val dispatcher = system.dispatcher
  implicit val materializer = ActorMaterializer()
  implicit val userFormat = jsonFormat4(User)

  val pool = Http().superPool[String]()
  
  val response: Future[Seq[User]] =
    Source.single(HttpRequest(uri = "http://localhost:58080/users") -> UUID.randomUUID().toString)
      .via(pool)
      .runWith(Sink.head)
      .flatMap {
        case (Success(response), _) => Unmarshal(response).to[Seq[User]]
        case _ => Future.successful(Seq[User]())
      }
  
   response
     .map(println(_))
     .andThen { case _ => Http().shutdownAllConnectionPools() }
     .andThen { case _ => system.terminate() }
}