package com.javacodegeeks.http

import akka.http.scaladsl.Http

import akka.actor.ActorSystem
import akka.stream.ActorMaterializer
import com.javacodegeeks.persistence.DbConfiguration
import com.javacodegeeks.persistence.UsersRepository

object Boot extends App with DbConfiguration with SslSupport {
  implicit val system = ActorSystem("akka-http-webapi")
  implicit val materializer = ActorMaterializer()
  implicit val executionContext = system.dispatcher

  val repository = new UsersRepository(config)
  val routes = new UserApi(repository).route
  
  Http().bindAndHandle(routes, "0.0.0.0", 58083, connectionContext = https)
  
  Http().bindAndHandle(routes, "0.0.0.0", 58080)
    .flatMap(r => repository.init())
}
